/* @ngInject */
function trustUrlFilter($sce) {
  return recordingUrl => $sce.trustAsResourceUrl(recordingUrl)
}
function trustHtmlFilter($sce) {
  return html => $sce.trustAsHtml(html)
}

function capitalizeFilter() {
  return function (input) {
    return (!!input) ? input.split(' ').map(function (wrd) { return wrd.charAt(0).toUpperCase() + wrd.substr(1).toLowerCase() }).join(' ') : ''
  }
}

trustUrlFilter.$inject = ['$sce']
trustHtmlFilter.$inject = ['$sce']

export { trustUrlFilter, trustHtmlFilter, capitalizeFilter }
