import 'bootstrap-sass/assets/stylesheets/_bootstrap.scss';

/* Angular Core */
import angular from 'angular'
/* Polyfills */
import '../assets/js/polyfills.js'

/* Angular Libs */
import uirouter from 'angular-ui-router'
import 'angular-touch'
import 'angular-sanitize'
import 'angular-animate'
import ngStorage from 'ngstorage'
import 'angular-bind-html-compile-ci-dev'
import '../assets/js/angular-sortable.js'

/* App Components */
import './components/questions/questions/questions.module'
import './components/questions/cloze/cloze.module'
import './components/questions/quiz/quiz.module'
import './components/questions/dropdown/dropdown.module'
import './components/questions/mix/mix.module'
import './components/questions/match/match.module'
import './components/questions/bucket/bucket.module'
import './common/header/header.module'
import './common/carousel/carousel.module'
import './common/selector/selector.module'
import './common/inputs/inputs.module'
import './common/player/player.module'
import './common/popup/popup.module'
import './common/loader/loader.module'
import './common/xxtea/xxtea.module'

/* App Configs */
import AppRun from './app.run'
import AppConstants from './app.constants'
import AppConfig from './app.config'
import { trustUrlFilter, trustHtmlFilter, capitalizeFilter } from './app.filters'

require('./main.scss')

const AppRequires = [
  uirouter,
  'ngSanitize',
  ngStorage.name,
  'ngTouch',
  'ng-sortable',
  'angular-bind-html-compile',
  'app.components.questions.questions',
  'app.components.questions.cloze',
  'app.components.questions.quiz',
  'app.components.questions.dropdown',
  'app.components.questions.mix',
  'app.components.questions.match',
  'app.components.questions.bucket',
  'app.common.header',
  'app.common.carousel',
  'app.common.selector',
  'app.common.inputs',
  'app.common.player',
  'app.common.popup',
  'app.common.loader',
  'app.common.xxtea',
]
angular
  .module('app', AppRequires)
  .run(AppRun)
  .constant('appConstants', AppConstants)
  .config(AppConfig)
  .filter('trustUrl', trustUrlFilter)
  .filter('trustHtml', trustHtmlFilter)
  .filter('capitalize', capitalizeFilter)
