/* @ngInject */
let carouselComponent = {
  bindings: {
    carouselList: '=',
    carouselIndex: '=',
    carouselArrowsShow: '='
  },
  controller: function ($scope, $element, $attrs, $swipe, $compile, $log, $timeout, $window, $document) {
    /* Setup carousel */
    let carousel = $element
    let slides = $element.find('slides')
    carousel.addClass('ng-carousel')
    slides.addClass('carousel-animate')

    /* Setup arrows */
    // Arrows HTML template
    let arrows = '<button class="carousel-arrow carousel-arrow-left" ng-click="prevSlide()" ng-if="current > 0 && $ctrl.carouselArrowsShow">' +
            '' +
            '</button>' +
            '<button class="carousel-arrow carousel-arrow-right" ng-click="nextSlide()" ng-if="current < total - 1 && $ctrl.carouselArrowsShow">' +
            '' +
            '</button>'


    /* Variables */
    $scope.current = 0
    $scope.total = $scope.$ctrl.carouselList
    $scope.$watch('$ctrl.carouselList', (n, o) => {
      $scope.total = n.length
      $scope.current = 0
    }, true)

    $scope.$watch('current', (n, o) => {
      $scope.$ctrl.carouselIndex = $scope.current
      move()
    })

    $scope.$watch('$ctrl.carouselIndex', (n, o) => {
      if ($scope.$ctrl.carouselIndex === 0) {
        $scope.current = 0
        move()
      } else {
        $scope.current = n
        move()
      }
    })

    /* Functions */
    function move(_offset) {
      let percent = $scope.current * 100
      let offset = _offset || 0
      let rule = 'translate(-' + (percent + offset) + '%, 0)'
      slides.css({
        '-webkit-transform': rule,
        '-moz-transform': rule,
        '-ms-transform': rule,
        '-o-transform': rule,
        'transform': rule
      })
    }

    $scope.prevSlide = () => {
      if ($scope.current > 0) {
        $scope.current--
      } else {
        $scope.current = $scope.total - 1
      }
    }

    $scope.nextSlide = () => {
      if ($scope.current < $scope.total - 1) {
        $scope.current++
      } else {
        $scope.current = 0
      }
    }

    const MAX_VERTICAL_DISTANCE = 75
    const MAX_VERTICAL_RATIO = 0.3
    const MIN_HORIZONTAL_DISTANCE = 30
    let startCoords, valid

    function validSwipe(coords, direction) {
      if (!startCoords) { return false }
      let deltaY = Math.abs(coords.y - startCoords.y)
      let deltaX = (coords.x - startCoords.x) * direction
      return valid && deltaY < MAX_VERTICAL_DISTANCE && deltaX > 0 && deltaX > MIN_HORIZONTAL_DISTANCE && deltaY / deltaX < MAX_VERTICAL_RATIO
    }

    $swipe.bind(carousel, {
      'start': function (coords, event) {
        startCoords = coords
        valid = true
      },
      'move': function (event) {
        // TODO
      },
      'cancel': function (event) {
        valid = false
      },
      'end': function (coords, event) {
        if (validSwipe(coords, 1)) {
          $scope.$apply(function () { $scope.prevSlide() })
        } else if (validSwipe(coords, -1)) {
          $scope.$apply(function () { $scope.nextSlide() })
        }
      }
    })

    /* Setup DOM */
    carousel.append($compile(arrows)($scope))

    /*angular.element($window).bind('resize', function() {
            var elements = slides.find('slide');
            var maxHeight = 0;
                 //Get the max height and set to the other div
            $timeout(function() {
                for (var i = 0; i < elements.length; i++) {
                    var elementHeight = elements[i].offsetHeight;
                    if (elements[i].offsetHeight > maxHeight) {
                        maxHeight = elementHeight;
                    }
                }
                for (var i = 0; i < elements.length; i++) {
                    angular.element(elements[i]).css('height', maxHeight + 'px');
                }
            });
        });*/
  }
}

export default carouselComponent
