import headerTemplate from './header.template.html'

/* @ngInject */
let headerComponent = {
  bindings: {
    headerInput: '=',
    headerStep: '=',
    headerSubStep: '=',
    headerAnswered: '=',
    headerQuestion: '=',
    headerReset: '<'
  },
  transclude: true,
  template: headerTemplate,
  controller: function ($scope, $location, $state, $localStorage, $window, $log, $timeout, $document) {

    $scope.questionTypes = ['questions']
    $scope.localStorage = $localStorage

    $scope.$watch('[$ctrl.headerInput,$ctrl.headerStep,$ctrl.headerSubStep]', (n, o) => {
      let path = $location.path()
      if (path.includes('/exercise/')) {
        let input = this.headerInput
        let _overall = 0
        let _current = 0
        if (input) {
          let type = input.interaction.interaction_type
          $scope.id = input.exercise_id
          if (type === 'bucket') {
            if (!input.interaction.questions[this.headerStep]) { return }
            let attempt = $scope.$ctrl.headerAnswered.find((a) => { return a.question === $scope.$ctrl.headerQuestion.question_id })
            $scope.pages = input.interaction.questions[this.headerStep].questions.map((q, i) => {
              let answered = attempt.attempts.find((a) => { return a.answer_index === i })
              return { number: i + 1, disabled: answered, active: i === this.headerSubStep }
            })
            _current = this.headerSubStep
          } else if (type === 'match') {
            if (!input.interaction.questions[this.headerStep]) { return }
            $scope.pages = input.interaction.questions[this.headerStep].set_a.map((q, i) => {
              let match = $scope.$ctrl.headerAnswered.find((m) => m.a.tile_data === q.tile_data)
              return { number: i + 1, disabled: match, active: i === this.headerSubStep }
            })
            _current = this.headerSubStep
          } else if (type === 'mix') {
            if (!input.interaction.questions[this.headerStep]) { return }
            $scope.pages = input.interaction.questions.map((q, i) => {
              let attempt = $scope.$ctrl.headerAnswered.find((a) => { return a.question === q.question_id })
              return { number: i + 1, disabled: attempt.attempts.length > 0, active: i === this.headerStep }
            })
            _current = this.headerStep
          } else if (type === 'quiz' || type === 'cloze' || type === 'dropdown') {
            $scope.pages = input.interaction.questions.map((q, i) => {
              return { number: i + 1, disabled: i < this.headerStep, active: i === this.headerStep }
            })
            _current = this.headerStep
          }

          if ($scope.pages.length >= 6) {
            let i, j, chunks = [], chunk = 6
            for (i = 0, j = $scope.pages.length; i < j; i += chunk) {
              chunks.push($scope.pages.slice(i, i + chunk))
            }

            let step = Math.floor(_current / chunk)
            $scope.pagesMobile = chunks[step]
          } else {
            $scope.pagesMobile = $scope.pages
          }
        }
      } else if (path.includes('exercise') || path.includes('playlist') || path.includes('overview')) {
        $scope.pages = $scope.exercises.map((q, i) => {
          return { number: i + 1, disabled: i < $localStorage.currentActiveExercise - 1, active: i === $localStorage.currentActiveExercise - 1 }
        })
      }
    })

    $scope.setQuestion = (step) => {
      let path = $location.path()
      if (path.includes('/exercise/')) {
        var input = this.headerInput
        if (input) {
          var type = input.interaction.interaction_type
          if (type === 'bucket') {
            $scope.$ctrl.headerSubStep = (step - 1)
          } else if (type === 'match') {
            $scope.$ctrl.headerSubStep = (step - 1)
          } else if (type === 'mix' || type === 'quiz' || type === 'cloze' || type === 'dropdown') {
            $scope.$ctrl.headerStep = (step - 1)
          }
          if ($scope.$ctrl.headerReset) {
            $scope.$ctrl.headerReset()
          }
        }
      } else if (path.includes('exercise') || path.includes('playlist') || path.includes('overview')) {
        $localStorage.currentActiveExercise = (step - 1)
      }
    }

    $scope.exercises = []
    $scope.questions = []
    $scope.currentActiveQuestion = $localStorage.currentActiveQuestion
    $scope.currentActiveExercise = $localStorage.currentActiveExercise

    $scope.isActive = location => {
      $scope.currentLocation = $location.absUrl().split('/').slice(-1)[0]
      // var currentLocation = currentLocation
      $scope.viewLocation = location
      var fl = $scope.currentLocation === $scope.viewLocation
      if ($scope.viewLocation === 'questions') {
        $scope.viewLocation = $location.absUrl().split('/')[4]
        fl = $scope.isQuestion($scope.viewLocation)
      }
      // var fl = viewLocation.some(v => currentLocation.includes(v))
      return fl
    }

    $scope.isQuestion = function(word) {
      if ($scope.questionTypes.includes(word)) {
        return true
      }
      else {
        return false
      }
    }

    $scope.questionLink = () => {
      $state.go('questions', $localStorage.questionLink)
    }

    $scope.isActiveQuestion = index => index === $localStorage.currentActiveQuestion

    /* MENU */
    $scope.menuOpened = false
    $scope.goBack = () => {
      $window.history.back()
    }

    if ($localStorage.exerciseCount) {
      for (let i = 1; i <= $localStorage.exerciseCount; i++) {
        $scope.exercises.push(i)
      }
    }

    if ($localStorage.questionCount) {
      for (let j = 1; j <= $localStorage.questionCount; j++) {
        $scope.questions.push(j)
      }
    }
  }
}
export default headerComponent
