/* @ngInject */
let inputsComponent = {
  bindings: {
    inputsType: '<',
    question: '=',
    answers: '=',
    queans: '=',
    step: '=',
    validation: '=',
    isTryAgain: '='
  },
  controller: function ($scope, $element, $attrs, $compile) {
    /* Validation */
    $scope.classValidation = (key) => {
      return ($scope.$ctrl.validation && $scope.$ctrl.validation.length > 0) && ($scope.$ctrl.validation[key] ? 'is-valid' : 'is-invalid')
    }

    $scope.hasIncorrectValidation = () => {
      if (angular.isUndefined($scope.$ctrl.validation) || $scope.$ctrl.validation.length === 0) {
        return true
      }
      return $scope.$ctrl.validation.length > 0 && ($scope.$ctrl.validation.includes(false))
    }
    /* Functions */
    function format() {
      let html = angular.copy($scope.$ctrl.question)
      if (!html) { return }
      const regexMultiples = /(\[[0-9]+\]?)/g
      const regexReplaceBreaks = /<br\s*\/?>/g
      const regexReplace = /\[([0-9]*?)\]/g
      const regexNumber = /[0-9]+/g

      // For dropdowns
      const templateDropdowns = '<select ng-disabled="$ctrl.isTryAgain" ng-if="hasIncorrectValidation()" class="form-control gel-select gel-select-inline" ng-class="classValidation(@key)" ng-model="$ctrl.queans[$ctrl.step][@key]">' +
                '<option value="">Select Options</option>' +
                '<option value="{{answer.replace(\' \', \'_\')}}" ng-repeat="answer in $ctrl.answers[@_keyIndex] track by $index">{{answer}}</option>' +
                '</select>' +
                '<span ng-if="!hasIncorrectValidation()" class="gel-inputs-valid">{{$ctrl.queans[$ctrl.step][@key]}}</span>'
      // For inputs
      const templateInputs = '<input autocorrect="off" autocapitalize="none" ng-disabled="$ctrl.isTryAgain" ng-if="hasIncorrectValidation()" type="text" class="form-control gel-input gel-input-inline" ng-class="classValidation(@key)" ng-model="$ctrl.queans[$ctrl.step][@key]">' +
                '<span ng-if="!hasIncorrectValidation()" class="gel-inputs-valid">{{$ctrl.queans[$ctrl.step][@key]}}</span>'
      //const templateInputsRow = '<div class="row">' +
      //  '<div class="col-md-10">@text</div>' +
      //'<div class="col-md-2">@input</div>' +
      //'</div>';

      if ($attrs.inputsType === 'dropdowns') {
        let t = $scope.$ctrl.queans[$scope.$ctrl.step]
        let matches = html.match(regexReplace)
        angular.forEach(matches, (k, m) => {
          let number = parseInt(k.match(regexNumber))
          let _template = templateDropdowns.replace(/@key/g, number)
          _template = _template.replace(/@_keyIndex/g, number - 1)
          html = html.replace(k, _template)
        })
      } else if ($attrs.inputsType === 'inputs') {
        let matchesWithQuestions = html.match(regexMultiples)
        angular.forEach(matchesWithQuestions, (v, k) => {
          let number = parseInt(v.match(regexNumber))
          let _templateInput = templateInputs.replace(/@key/g, number)
          html = html.replace(v, _templateInput)
        })


        let matches = html.match(regexReplace)
        angular.forEach(matches, (k, m) => {

        })
      }

      html = '<div class="gel-inputs-container ' + $attrs.inputsType + '">' + html + '</div>'
      $element.replaceWith($compile(html)($scope))
    }

    $scope.$watch('$ctrl.question', () => format(), true)
  }
}

export default inputsComponent
