/* @ngInject */
let selectorComponent = {
  bindings: {
    selectorList: '<',
    selectorKey: '<',
    selectorIndex: '=',
    selectorIndexes: '=',
    selectorCorrect: '=',
    selectorType: '<'
  },
  controller: function ($scope, $element, $attrs, $swipe, $compile, $log) {
    /* Setup selector */
    let selector = $element
    selector.append('<items></items>')
    let items = $element.find('items')
    selector.addClass('ng-selector')

    $scope.selectorKey = $attrs.selectorKey

    /* Setup buttons */
    // Buttons HTML template
    let buttonsRadios = '<button class="radio" ng-click="$ctrl.selectorCorrect ? null : check($index)" ng-class="{\'checked\':$index===$ctrl.selectorIndex,\'success\':$ctrl.selectorCorrect===\'yes\'&&$index===$ctrl.selectorIndex,\'failure\':$ctrl.selectorCorrect===\'no\'&&$index===$ctrl.selectorIndex}" ng-repeat="answer in $ctrl.selectorList">' +
            '<div ng-bind-html="selectorKey ? answer[selectorKey] : answer | trustHtml"></div> <div class="icon"></div>' +
            '</button>'

    let buttonsCheckboxes = '<button class="checkbox" ng-click="$ctrl.selectorCorrect ? null : check($index)" ng-class="{\'checked\':isChecked($index),\'success\':$ctrl.selectorCorrect===\'yes\'&&isChecked($index),\'failure\':$ctrl.selectorCorrect===\'no\'&&isChecked($index)}" ng-repeat="answer in $ctrl.selectorList">' +
            '<div ng-bind-html="selectorKey ? answer[selectorKey] : answer | trustHtml"></div> <div class="icon"></div>' +
            '</button>' +
            '{{$attrs}}'

    /* Functions */
    // Check item
    $scope.isChecked = (index) => {
      if (angular.isUndefined($scope.$ctrl.selectorIndexes)) { return false }
      return $scope.$ctrl.selectorIndexes.indexOf(index) !== -1
    }
    $scope.check = (index) => {
      if ($attrs.selectorType === 'radio') {
        $scope.$ctrl.selectorIndex = index
      } else if ($attrs.selectorType === 'checkbox') {
        if (angular.isUndefined($scope.$ctrl.selectorIndexes)) {
          $scope.$ctrl.selectorIndexes = []
        }
        let elIndex = $scope.$ctrl.selectorIndexes.indexOf(index)
        if (elIndex !== -1) {
          $scope.$ctrl.selectorIndexes.splice(elIndex, 1)
        } else {
          $scope.$ctrl.selectorIndexes.push(index)
        }
      }
    }

    /* Setup DOM */
    if ($attrs.selectorType === 'radio') {
      items.append($compile(buttonsRadios)($scope))
    } else if ($attrs.selectorType === 'checkbox') {
      items.append($compile(buttonsCheckboxes)($scope))
    }
  }
}

export default selectorComponent
