import questionsTemplate from './questions.template.html'

/* @ngInject */
let questionsComponent = {
  template: questionsTemplate,
  transclude: true,
  controller: function ($scope, $http, $state, $stateParams, $timeout, appConstants, $localStorage) {

    function setupExercise(exerciseData) {
      $scope.exercise = exerciseData
    }

    // Get exercise data and setup
    if ($stateParams.id) {
      $http({ method: 'GET', url: appConstants.api + '/exercise/' + $stateParams.id + '/' + $stateParams.sid  })
        .then((response) => {
          $scope.exercise = response.data
          $scope.qid = $stateParams.id
          $scope.sid = $stateParams.sid
          $localStorage.$reset()
          $localStorage.exercises = []
          $localStorage.questionCount = $scope.exercise.interaction.questions.length
          $localStorage.questions = $scope.exercise.interaction.questions
          $localStorage.currentActiveExercise = 1
          $localStorage.currentActiveQuestion = $scope.step + 1
          // Assign new data
          $localStorage.playlist = [response.data]
          $localStorage.exerciseCount = $localStorage.playlist.length
          $localStorage.currentExercise = response.data.exercise_id
          $localStorage.currentActiveExercise = 1
          $timeout(() => { $state.go('exercise') })
        })
    }
    else { // If we have loaded playlist then load the exercise from playlist
      setupExercise($localStorage.playlist.find((item) => item.exercise_id === $localStorage.currentExercise))
    }
  }

}
export default questionsComponent
