import webpack from 'webpack';
import path from 'path';
import WebpackConfig from 'webpack-config';
import HtmlWebpackPlugin from 'html-webpack-plugin';

const plugins = [
  new webpack.optimize.CommonsChunkPlugin({
    name: 'vendor',
    filename: 'vendor.js',
  }),
  new HtmlWebpackPlugin({
    title: 'Guided E-Learning',
    template: 'index.ejs',
    inject: 'body'
  })
]

module.exports = new WebpackConfig().extend('./webpack.config.common.babel.js').merge({
  output: {
    pathinfo: true,
    filename: '[name].entry.js'
  },
  devtool: '#eval',
  entry: {
    bundle: path.join(__dirname, '/app/app.module.js'),
    vendor: ['angular', 'angular-ui-router'],
  },
  plugins: plugins
});
